USE project;

/*
---------------------------------- 1 ----------------------------------
Geben Sie mit SQL alle Menüs mit den darin enthaltenen Produkten menschenlesbar
als eine Art Speisekarte aus.
-----------------------------------------------------------------------
*/
SELECT Menuname, GROUP_CONCAT(Produktname SEPARATOR ', ') AS 'Produkte'
FROM Menu
         JOIN Menucontent M on Menu.MenuID = M.MenuID
         JOIN Menge M2 on M.MengenID = M2.MengenID
         JOIN Produkt P on M2.ProduktID = P.ProduktID
GROUP BY Menuname;


/*
---------------------------------- 2 ----------------------------------
Erweitern Sie die Ausgabe aus der vorherigen Abfrage um hilfreiche Informationen
bezüglich der Gesamtnährwerte dieser Menüs.
-----------------------------------------------------------------------
*/
SELECT Menuname,
       GROUP_CONCAT(Produktname SEPARATOR ', ')                                         AS 'Produkte',
       SUM(Fett * (SELECT Menge FROM Menge WHERE MengenID = M.MengenID) / 100)          AS 'Fett',
       SUM(Kohlenhydrate * (SELECT Menge FROM Menge WHERE MengenID = M.MengenID) / 100) AS 'Kohlenhydrate',
       SUM(Eiweiss * (SELECT Menge FROM Menge WHERE MengenID = M.MengenID) / 100)       AS 'Eiweiss',
       SUM(Brennwert * (SELECT Menge FROM Menge WHERE MengenID = M.MengenID) / 100)     AS 'Brennwert'
FROM Menu
         JOIN Menucontent M on Menu.MenuID = M.MenuID
         JOIN Menge M3 on M.MengenID = M3.MengenID
         JOIN Produkt P on M3.ProduktID = P.ProduktID
         JOIN Naehrwerte N on P.ProduktID = N.ProduktID
GROUP BY Menuname;


/*
---------------------------------- 3 ----------------------------------
Geben sie mit SQL alle Produkte mit für Kundinnen und Kunden relevanten Informationen für
eine bestimmte Person aus (betreffend Allergenen, Unverträglichkeiten, vegetarisch, etc.).
-----------------------------------------------------------------------
TODO Redo
*/
SELECT Personenvorname,
       Personenname,
       GROUP_CONCAT(DISTINCT P.Produktname SEPARATOR ', ')
FROM Person
         JOIN Allergie A on Person.PersonID = A.PersonID
         JOIN Allergen A2 on A.AllergenID = A2.AllergenID
         JOIN enthaeltAllergen eA on A2.AllergenID = eA.AllergenID
         JOIN Produkt P on eA.ProduktID = P.ProduktID
         JOIN enthaeltZusatzstoff eZ on P.ProduktID = eZ.ProduktID
GROUP BY Personenvorname, Personenname;


/*
---------------------------------- 4 ----------------------------------
Sortieren Sie alle enthaltenen Produkte absteigend nach Anzahl der enthaltenen Zusatzstoffe.
-----------------------------------------------------------------------
*/
SELECT Produktname,
       LENGTH(GROUP_CONCAT(E_Nummer)) - LENGTH(REPLACE(GROUP_CONCAT(E_Nummer), ',', '')) + 1 AS 'Anzahl Zusatzstoffe'
FROM Produkt
         JOIN enthaeltZusatzstoff eZ on Produkt.ProduktID = eZ.ProduktID
GROUP BY Produktname
ORDER BY LENGTH(GROUP_CONCAT(E_Nummer)) - LENGTH(REPLACE(GROUP_CONCAT(E_Nummer), ',', '')) + 1 DESC;


/*
---------------------------------- 5 ----------------------------------
Sortieren Sie alle [in der Datenbank (anm. d. St.)] enthaltenen Produkte aufsteigend nach Kalorienanzahl in der Portion, die verkauft wird.
Hinweis: Produkte ohne Brennwert werden nicht angezeigt
-----------------------------------------------------------------------
*/
SELECT Produktname,
       ROUND(Brennwert * (M.Menge / 100), 1) AS Brennwert,
       M.Menge,
       M.Einheit
FROM Produkt
    JOIN Naehrwerte N on Produkt.ProduktID = N.ProduktID
    JOIN Menge M on Produkt.ProduktID = M.ProduktID
ORDER BY Brennwert;

/*
---------------------------------- 6 ----------------------------------
Geben Sie eine SQL Anfrage an, die alle Produkte ausgibt, die eine bestimmte Anzahl von Emulgatoren enthalten.
    a. Keine Emulgatoren
    b. 1 Emulgator
    c. 2 Emulgatoren
    d. Mehr
-----------------------------------------------------------------------
*/

SELECT Produktname,
       IFNULL( # wenn feld NULL, Keine Emulgatoren
           REPLACE( # wenn feld zero, Keine Emulgatoren
               REPLACE( # wenn feld zwei, Zwei Emulgatoren
                    REPLACE( # wenn feld eins, Ein Emulgator
                        IF(     # wenn feld größer als zwei, Mehr Emulgatoren, ansonsten setze den gleichen wert wieder ins feld
                            LENGTH(GROUP_CONCAT(eZ.Anwendungsgrund)) - LENGTH(REPLACE(GROUP_CONCAT(eZ.Anwendungsgrund), 'E', ''))
                                > 2, 'Mehr Emulgatoren',
                            LENGTH(GROUP_CONCAT(eZ.Anwendungsgrund)) - LENGTH(REPLACE(GROUP_CONCAT(eZ.Anwendungsgrund), 'E', '')))
                    , 1, 'Ein Emulgator')
                , 2, 'Zwei Emulgatoren')
            , 0, 'Keine Emulgatoren')
        , 'Keine Emulgatoren')
       AS Emgulagtoren,
       GROUP_CONCAT(eZ.Anwendungsgrund) AS 'Anwendungsgrund'
FROM Produkt
         LEFT JOIN enthaeltZusatzstoff eZ on Produkt.ProduktID = eZ.ProduktID
GROUP BY Produktname
ORDER BY LENGTH(GROUP_CONCAT(eZ.Anwendungsgrund)) - LENGTH(REPLACE(GROUP_CONCAT(eZ.Anwendungsgrund), 'E', ''))